
"""
A simple line search, in fact no searches at all
"""

class SimpleLineSearch(object):
  """
  A simple line search, takes a point, adds a step and returns it
  """
  def __init__(self, **kwargs):
    """
    Needs to have :
      - nothing
    Can have :
      - a step modifier, a factor to modulate the step (stepSize = 1.)
    """
    self.stepSize = kwargs.get('stepSize', 1.)

  def __call__(self, origin, step, state, **kwargs):
    """
    Returns a good candidate
    Parameters :
      - origin is the origin of the search
      - step is the step that will be used
      - state is the state of the optimizer
    """
    state['step_size'] = self.stepSize
    return origin + self.stepSize * step

