"""
Module containing every step use to lower a cost function

Steps :
  - GradientStep
    - compute a step based on the gradient of the function
  - Newton
    - computes a step based on the hessian and the gradient of the function
"""

from gradient_step import *
from newton_step import *
from fletcher_reeves_conjugate_gradient_step import *

__all__ = ['gradient_step', 'newton_step', 'fletcher_reeves_conjugate_gradient_step']